HDU1711-Number Sequence-KMP算法(模板)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1711

这个一个字符串匹配的模板题;

其实KMP算法很好理解,但是如果初次接触的话,理解他怎么来的next数组可能会比较吃力;我这里就暂且笼统的讲一下吧。

对于我们要查询的字符串,我们先对他进行前缀和后缀的处理,保存在next数组内;比如这串数字

b[]=    1  2  3  4  1  2  4

next=  -1  0  0  0  0  1  2    我们用-1标记起始;next=1,表示前缀和后缀只有一个字符相匹配;我们用next保存之后,

当我们和给出的被查找数组a[]匹配的时候就可以达到线性匹配;为什么呢??因为当我们匹配好了一串字符串之后,我们不用返回到前面刚开始匹配的位置+1开始匹配;

因为我们事先对a[]进行了一遍查找,找出了前缀和后缀相同的个数;这样我们就可以直接往后移动(匹配的位数-相同位数)这么多位,避免了前面很多不需要的比较;

这样我们就可以达到时间复杂度为O(n+m)了;代码也不复杂,效率也不错,所以在字符串匹配中KMP是很常用的一种;

这里推荐一个博客,里面对KMP的过程介绍的特别的详细; 链接:http://kb.cnblogs.com/page/176818/

#include<iostream>
#include<string>
#include<cstring>
#include<cstdio>
#include<algorithm>
using namespace std;
const int N=200005;
int a[N*10],b[N],Next[N];
void Get_Next(int m)        //  得到Next数组;
{
    int i=0,j=-1;
    Next[0]=-1;
    while(i<m){
        if(j==-1||b[i]==b[j]) Next[++i]=++j;
        else j=Next[j];
    }
    return;
}
int KMP(int n,int m)        //  KMP匹配;
{
    int i=0,j=0;
    while(i<n){
        if(a[i]==b[j]){
            if(j==m-1) return i-m+2;
            i++,j++;
        }else{
            j=Next[j];
            if(j==-1) i++,j=0;
        }
    }
    return -1;
}
int main()
{
    int t,m,n;
    scanf("%d",&t);
    while(t--){
        scanf("%d%d",&n,&m);
        for(int i=0;i<n;i++) scanf("%d",&a[i]);
        for(int i=0;i<m;i++) scanf("%d",&b[i]);
        if(m>n) printf("-1\n");
        else{
            Get_Next(m);
            printf("%d\n",KMP(n,m));
        }
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-12-16 21:51:54

HDU1711-Number Sequence-KMP算法(模板)的相关文章

HDU 1711 Number Sequence(KMP算法)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1711 Number Sequence Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 15548    Accepted Submission(s): 6836 Problem Description Given two sequence

hdu1711 Number Sequence kmp应用

题目地址:http://acm.hdu.edu.cn/showproblem.php?pid=1711 题目: Problem Description Given two sequences of numbers : a[1], a[2], ...... , a[N], and b[1], b[2], ...... , b[M] (1 <= M <= 10000, 1 <= N <= 1000000). Your task is to find a number K which m

HDU1711 Number Sequence KMP

欢迎访问~原文出处--博客园-zhouzhendong 去博客园看该题解 题目传送门 - HDU1711 题意概括 给T组数据,每组有长度为n和m的母串和模式串.判断模式串是否是母串的子串,如果是输出最先匹配完成的位置,否则输出-1. 题解 KMP裸题. 代码 #include <cstring> #include <algorithm> #include <cstdio> #include <cstdlib> #include <cmath>

hdu 1711 KMP算法模板题

题意:给你两个串,问你第二个串是从第一个串的什么位置開始全然匹配的? kmp裸题,复杂度O(n+m). 当一个字符串以0为起始下标时.next[i]能够描写叙述为"不为自身的最大首尾反复子串长度". 当发生失配的情况下,j的新值next[j]取决于模式串中T[0 ~ j-1]中前缀和后缀相等部分的长度, 而且next[j]恰好等于这个最大长度. 防止超时.注意一些细节.. 另外:尽量少用strlen.变量记录下来使用比較好,用字符数组而不用string //KMP算法模板题 //hdu

hdu 1711 Number Sequence(KMP)

# include <stdio.h> # include <string.h> # include <algorithm> using namespace std; int n,m,next[10010],a[1000010],b[10010]; void Getnext() { int i=0,j=-1; next[0]=-1; while(i<m) { if(j==-1||b[i]==b[j]) i++,j++,next[i]=j; else j=next[

HDU 1711 Number Sequence KMP题解

KMP查找整数数列,不是查找字符串. 原理是一样的,不过把字符串转换为数列,其他基本上是一样的. #include <stdio.h> #include <string.h> const int MAX_N = 1000001; const int MAX_M = 10001; int strN[MAX_N], strM[MAX_M], next[MAX_M], N, M; void getNext() { memset(next, 0, sizeof(int) * M); for

HDU 1711 Number Sequence(KMP模板)

Problem Description: Given two sequences of numbers : a[1], a[2], ...... , a[N], and b[1], b[2], ...... , b[M] (1 <= M <= 10000, 1 <= N <= 1000000). Your task is to find a number K which make a[K] = b[1], a[K + 1] = b[2], ...... , a[K + M - 1]

Problem A Number Sequence(KMP基础)

A - Number Sequence Time Limit:5000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 1711 Description Given two sequences of numbers : a[1], a[2], ...... , a[N], and b[1], b[2], ...... , b[M] (1 <= M <= 100

hdu 1711 Number Sequence KMP 基础题

Number Sequence Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 11691    Accepted Submission(s): 5336 Problem Description Given two sequences of numbers : a[1], a[2], ...... , a[N], and b[1],

(KMP 1.1)hdu 1711 Number Sequence(KMP的简单应用——求pattern在text中第一次出现的位置)

题目: Number Sequence Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 12902    Accepted Submission(s): 5845 Problem Description Given two sequences of numbers : a[1], a[2], ...... , a[N], and b[1